﻿package test 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import test.base.GameSceneBase;
	import test.base.SceneBase;
	import kinkuma.BAS3Trigger;
	import org.libspark.betweenas3.easing.*;
	import org.libspark.next.*;
	/**
	 * ...
	 * @author KinkumaDesign
	 */
	public class GameScene extends SceneBase
	{
		public var popupBtn:MovieClip;
		public var titleBtn:MovieClip;
		private var _childScene:SceneBase;
		
		public function GameScene() 
		{
			
		}
		
		override public function startScene():ITrigger 
		{
			var self:GameScene = this;
			var tr:Trigger = new Trigger();
			alpha = 0;
			N.push(BAS3Trigger, this, { alpha:1 }, 0.6, Quad.easeIn)
			.func(function() {
				self.popupBtn.addEventListener(MouseEvent.CLICK, self.popupClickHD);
				self.titleBtn.addEventListener(MouseEvent.CLICK, self.titleClickHD);
				tr.call();
			}).start();
			return tr;
		}
		
		private function popupClickHD(e:MouseEvent):void 
		{
			_childScene = new PopupScene();
			addChild(_childScene);
			var self:GameScene = this;
			Main.getInstance().setMouseEventEnable(false);
			N.push(_childScene.startScene)
			.func(function() {
				self._childScene.addEventListener(Event.COMPLETE, self.childSceneCompleteHD);
				Main.getInstance().setMouseEventEnable(true);
			}).start();
		}
		
		private function childSceneCompleteHD(e:Event):void 
		{
			_childScene.removeEventListener(Event.COMPLETE, childSceneCompleteHD);
			
			Main.getInstance().setMouseEventEnable(false);
			
			var self:GameScene = this;
			N.push(_childScene.stopScene)
			.func(function() {
				self.childSceneTransitionCompleteHD();
				Main.getInstance().setMouseEventEnable(true);
			}).start();
		}
		
		private function childSceneTransitionCompleteHD():void
		{
			removeChild(_childScene);
			
			_nextScene = _childScene.getNextScene();
			
			//何もしない
			if (_nextScene == null) {
			
			//GameSceneの子シーンになれるんだったら
			}else if (_nextScene is GameSceneBase) {
				/*
				 * 子シーンを追加してchildSceneCompleteHDを登録する処理
				 * 今回は別の子シーンがないので何もしない
				 */
				
			//子シーンでない場合は親に通達する
			}else {
				dispatchCompleteEvent();
			}
		}
		
		private function titleClickHD(e:MouseEvent):void 
		{
			_nextScene = new TopScene();
			dispatchCompleteEvent();
		}
		
		override public function stopScene():ITrigger 
		{
			popupBtn.removeEventListener(MouseEvent.CLICK, popupClickHD);
			titleBtn.removeEventListener(MouseEvent.CLICK, titleClickHD);
			var tr:Trigger = new Trigger();
			N.push(BAS3Trigger, this, { alpha:0 }, 0.4, Quad.easeIn)
			.func(function() {
				tr.call();
			}).start();
			return tr;
		}
	}

}